# class Prism::ArgumentsNode

Represents a set of arguments to a method or a keyword.

    return foo, bar, baz
           ^^^^^^^^^^^^^

### Attributes

arguments [R]

The list of arguments, if present. These can be any [non-void expressions](github.com/ruby/prism/blob/main/docs/parsing_rules.md#non-void-expression).

    foo(bar, baz)
        ^^^^^^^^

### Public Class Methods

new (source, node_id, location, flags, arguments)
Source

    # File lib/prism/node.rb, line 764
    def initialize(source, node_id, location, flags, arguments)
      @source = source
      @node_id = node_id
      @location = location
      @flags = flags
      @arguments = arguments
    end

Initialize a new `ArgumentsNode` node.

type ()
Source

    # File lib/prism/node.rb, line 847
    def self.type
      :arguments_node
    end

Return a symbol representation of this node type. See ‘Node::type`.

### Public Instance Methods

=== (other)
Source

    # File lib/prism/node.rb, line 853
    def ===(other)
      other.is_a?(ArgumentsNode) &&
        (flags === other.flags) &&
        (arguments.length == other.arguments.length) &&
        arguments.zip(other.arguments).all? { |left, right| left === right }
    end

Implements case-equality for the node. This is effectively == but without comparing the value of locations. Locations are checked only for presence.

accept (visitor)
Source

    # File lib/prism/node.rb, line 773
    def accept(visitor)
      visitor.visit_arguments_node(self)
    end

def accept: (`Visitor` visitor) -> void

child_nodes ()
Source

    # File lib/prism/node.rb, line 778
    def child_nodes
      [*arguments]
    end

def `child_nodes`: () -> Array[nil | Node]

Also aliased as: deconstruct
comment_targets ()
Source

    # File lib/prism/node.rb, line 788
    def comment_targets
      [*arguments] #: Array[Prism::node | Location]
    end

def `comment_targets`: () -> Array[Node | Location]

compact_child_nodes ()
Source

    # File lib/prism/node.rb, line 783
    def compact_child_nodes
      [*arguments]
    end

def `compact_child_nodes`: () -> Array

contains_forwarding? ()
Source

    # File lib/prism/node.rb, line 806
    def contains_forwarding?
      flags.anybits?(ArgumentsNodeFlags::CONTAINS_FORWARDING)
    end

def contains_forwarding?: () -> bool

contains_keyword_splat? ()
Source

    # File lib/prism/node.rb, line 816
    def contains_keyword_splat?
      flags.anybits?(ArgumentsNodeFlags::CONTAINS_KEYWORD_SPLAT)
    end

def contains_keyword_splat?: () -> bool

contains_keywords? ()
Source

    # File lib/prism/node.rb, line 811
    def contains_keywords?
      flags.anybits?(ArgumentsNodeFlags::CONTAINS_KEYWORDS)
    end

def contains_keywords?: () -> bool

contains_multiple_splats? ()
Source

    # File lib/prism/node.rb, line 826
    def contains_multiple_splats?
      flags.anybits?(ArgumentsNodeFlags::CONTAINS_MULTIPLE_SPLATS)
    end

def contains_multiple_splats?: () -> bool

contains_splat? ()
Source

    # File lib/prism/node.rb, line 821
    def contains_splat?
      flags.anybits?(ArgumentsNodeFlags::CONTAINS_SPLAT)
    end

def contains_splat?: () -> bool

copy (node_id: self.node_id, location: self.location, flags: self.flags, arguments: self.arguments)
Source

    # File lib/prism/node.rb, line 793
    def copy(node_id: self.node_id, location: self.location, flags: self.flags, arguments: self.arguments)
      ArgumentsNode.new(source, node_id, location, flags, arguments)
    end

def copy: (?node_id: `Integer`, ?location: `Location`, ?flags: `Integer`, ?arguments: Array) -> `ArgumentsNode`

deconstruct ()

def deconstruct: () -> Array[nil | Node]

Alias for: child_nodes
deconstruct_keys (keys)
Source

    # File lib/prism/node.rb, line 801
    def deconstruct_keys(keys)
      { node_id: node_id, location: location, arguments: arguments }
    end

def `deconstruct_keys`: (Array keys) -> { node_id: `Integer`, location: `Location`, arguments: Array }

inspect ()
Source

    # File lib/prism/node.rb, line 837
    def inspect
      InspectVisitor.compose(self)
    end

def inspect -> `String`

type ()
Source

    # File lib/prism/node.rb, line 842
    def type
      :arguments_node
    end

Return a symbol representation of this node type. See ‘Node#type`.